# -*- coding: utf-8 -*-
import sys,os

 # Font-Cache-Parser: looks recursively in a given font-path for fonts.cache to grab the real fontfile
 #
 # Usage:    from <this> import *
 #           fontStringProcess('<QFontDialog string>')                            : returns formatted font request
 #           fontDirProcess('<font-dir>','<return from fontStringProcess()>')     : returns all needed stuff

 # styles:	- Regular	Times New Roman,12,-1,5,50,0,0,0,0,0
 #		- Bold		Times New Roman,12,-1,5,75,0,0,0,0,0
 #		- Italic	Times New Roman,12,-1,5,50,1,0,0,0,0
 #		- Bold Italic	Times New Roman,12,-1,5,75,1,0,0,0,0

 # returns the given font request formatted
def fontStringProcess(s):
	s = s.split(',')
	
	# fontname
	fontName = s[0]
	
	# pixel
	pxSize = s[1]
	
	# style
	if (s[4] == '50') and (s[5] == '0'):
		style = 'style=Regular'
	
	elif (s[4] == '50') and (s[5] == '1'):
		style = 'style=Italic'
	
	elif (s[4] == '75') and (s[5] == '0'):
		style = 'style=Bold'
	
	else:
		style = 'style=Bold Italic'
	
	return fontName,pxSize,style


 # opens cache-files in the given dir recursively, formats the contents to get the real filename of the font
def fontDirProcess(dir_,font):
	
	try:
		lines = ''
		dir_ = dir_.replace('~',os.path.expanduser('~'))
		f = open(dir_+'/fonts.cache-1')
		lines = f.readlines()
		f.close()
	except IOError, (errno, strerror):
		print "I/O error(%s): %s" % (errno, strerror)
	else:
		# process only if filehandling was successful
		for i in range(len(lines)):
			times = lines[i]
			times = times.split('"')
			if times[3] == '.dir':
				result = fontDirProcess(dir_+'/'+times[1],font)
				if result !='none':
					return result
			
			process = times[3].split(':')
			
			# Do the fontnames match?
			if font[0] == process[0]:
				
				# try to get the style flag
				for j in range( len(process) ):
					if process[j].find('style=') != -1:
						style = process[j].split(',')[0]
				if font[2] == style:
					
					# filename
					filename = times[1]
					
					# type could be TTF, PCF, Type 1
					fontType = process[len(process)-1]
					if fontType !='fontformat=TrueType':
						
						# get the filetype with file
						if os.popen2('file %s' %(dir_+'/'+filename))[1].read().find('TrueType font') != -1:
							fontType = 'fontformat=TrueType'
						
					return dir_+'/'+filename,process[0],font[1],style,fontType
	return 'none'
