# -*- coding: utf-8 -*-

 # Font-Config-Parser: little function to get all known fontdirs from the main-configs
 #                    conf-files are xml-style, we only have to catch the content of <dir></dir>
 #                    THE FUNCTION DOESN'T A RECURSIVE LOOK FOR CONF-FILES!!!
 #
 # Usage:   from <this> import FontDir
 #          FontDir('<conf-path>')            :returns all fontdirs found as tuple
 #
import xml,sys,os
from xml.sax import saxutils,make_parser
from xml.sax.handler import feature_namespaces


class MyHandler(saxutils.handler.ContentHandler):
	def __init__(self,element):
		self.inDir = False
		self.my_element = element
		self._back = ''
		
	def startElement(self, name, attrs):
		if name == self.my_element:
			self.inDir = True
			self.dirContent = ''
	
	def characters(self, content):
        	if self.inDir:
        		self.dirContent = content
		
	
	def endElement(self, name):
		if name == self.my_element:
			self.inDir = False
			self._back = self._back + ';' + self.dirContent
		
	def back(self):
		return self._back
	
class MyError(saxutils.handler.ErrorHandler):
	
	def fatalError(self, exception):
		sys.stderr.write("\%s\n" % exception)
	
	def error(self, exception):
		sys.stderr.write("\%s\n" % exception)

def _fontDir(file):
	parser = make_parser()
	parser.setFeature(feature_namespaces, 0)
	my_h = MyHandler('dir')
	my_e = MyError()
	parser.setContentHandler(my_h)
	parser.setErrorHandler(my_e)
	parser.parse(file)
	return my_h.back()

def FontDir(dir_):
	pathlistOut = ''
	filelist = os.listdir(dir_)
	for i in range( len(filelist) ):
		file_ = filelist[i].split('.')
		if file_[1].find('conf') == 0:
			pathlist = _fontDir(dir_+'/'+filelist[i])
			if pathlist:
				 pathlistOut = pathlistOut + pathlist
	return pathlistOut.split(';')[1:]
