# -*- coding: utf-8 -*-

         #########################
         #                       #
         #    ButtonMaker 0.1a   #
         #                       #
         #########################

 # author:  Jerch <brejoe(at)web.de>
 # date:    06/20/2005
 # lisense: GPL

 # dependencies:      - PyQT (QT/KDE-Bindings for Python)
 #                    - PIL  (Python Image Library)
 #                    - XML-Support for Python
 #                    - a lot of TrueTypeFonts

 # missing features and todo:
 #	- images
 #	- display selected colour on dialogButton
 #	- magnify look
 #	- load and save presets, list with fonts, maybe under ~/.buttonmaker/
 #	- exceptions
 #	- comments
 #	- scaling of pictures etc.
 #	- better font support (TTF, and what about PCF and Type-1?)
 #	- direct preview:    - from dialogs
 #	                     - from lineEdits after <enter>

 # ATTENTION: - after rebuilding Form.ui with pyuic edit in Form.py:
 #                      self.groupBox3 = QGroupBox(self,"groupBox3") to    ... QButtonGroup(self,"groupBox3")
 #                      self.groupBox3_2 = QGroupBox(self,"groupBox3_2") to    ... QButtonGroup(self,"groupBox3_2")
 # I was to lazy to change it with the Designer.

from qt import *
import sys,os

from Form import Form1
from my_image import My_Image
from fontConfig import FontDir
from fontCache import *


class Go(Form1):
	def __init__(self,parent = None,name = None,fl = 0):
        	Form1.__init__(self,parent,name,fl)
		
		self.connect(self.butPreview,SIGNAL("clicked()"),self.update_all)
		self.connect(self.butColorOut,SIGNAL("clicked()"),self.color_out)
		self.connect(self.butColorIn,SIGNAL("clicked()"),self.color_in)
		self.connect(self.butTextcolorLeft,SIGNAL("clicked()"),self.color_textLeft)
		self.connect(self.butBackcolorLeft,SIGNAL("clicked()"),self.color_backLeft)
		self.connect(self.butTextcolorRight,SIGNAL("clicked()"),self.color_textRight)
		self.connect(self.butBackcolorRight,SIGNAL("clicked()"),self.color_backRight)
		self.connect(self.butColorOut_2,SIGNAL("clicked()"),self.color)
		self.connect(self.butFontLeft,SIGNAL("clicked()"),self.font_left)
		self.connect(self.butFontRight,SIGNAL("clicked()"),self.font_right)
		self.connect(self.butSave,SIGNAL("clicked()"),self.save)
		self.connect(self.butInfo,SIGNAL("clicked()"),self.info)
		
		# allow only hex-specific letters
		self.hexExp = QRegExp( "[a-f,A-F,0-9]{6}" )
		self.validator = QRegExpValidator( self.hexExp, self )
		self.lineBackColour.setValidator( self.validator )
		self.lineColorOut.setValidator( self.validator )
		self.lineColorIn.setValidator( self.validator )
		self.lineTextcolorLeft.setValidator( self.validator )
		self.lineBackcolorLeft.setValidator( self.validator )
		self.lineTextcolorRight.setValidator( self.validator )
		self.lineBackcolorRight.setValidator( self.validator )
		
		# create button-picture-object
		self.my_img = My_Image()
		
		# font-setup
		self.FontInit = True
		self.qFontLeft = QFont("Times",12)
		self.qFontRight = QFont("Times",12)
		self.LeftFont = ''
		self.LeftFontSize = 0
		self.RightFont = ''
		self.RightFontSize = 0
		self.font = 'Times New Roman,12,-1,5,50,0,0,0,0,0'         # should exist on nearly every computer
		self.FontConf = '/etc/fonts'
		self.fontTest('none')
		
		# disable text functions without any font
		if self.FontInit == False:
			self.lineTextLeft.setEnabled(0)
			self.butFontLeft.setEnabled(0)
			self.lineTextcolorLeft.setEnabled(0)
			self.butTextcolorLeft.setEnabled(0)
			self.spinTextposLeftX.setEnabled(0)
			self.spinTextposLeftY.setEnabled(0)
			self.checkLeftTextAutoX.setEnabled(0)
			self.checkLeftTextAutoY.setEnabled(0)
			self.lineTextRight.setEnabled(0)
			self.butFontRight.setEnabled(0)
			self.lineTextcolorRight.setEnabled(0)
			self.butTextcolorRight.setEnabled(0)
			self.spinTextPosRightX.setEnabled(0)
			self.spinTextposRightY.setEnabled(0)
			self.checkRightTextAutoX.setEnabled(0)
			self.checkRightTextAutoY.setEnabled(0)
			
		# first run with defaults
		self.update_all()
		
	# function to set all ness. stuff
	def setProp(self,img):
		img.X = self.spinPixX.value()
		img.Y = self.spinPixY.value()
		img.BackColor = '#'+self.lineBackColour.text().ascii()
		img.BorderOutColor = '#'+self.lineColorOut.text().ascii()
		img.BorderOutThick = self.spinThickOut.value()
		img.BorderInColor = '#'+self.lineColorIn.text().ascii()
		img.BorderInThick = self.spinThickIn.value()
		img.BoxLeft.X = self.spinLeftX2.value()
		img.BoxLeft.Y = self.spinLeftY2.value()
		img.BoxLeft.posX = self.spinLeftX1.value()
		img.BoxLeft.posY = self.spinLeftY1.value()
		img.BoxLeft.Text = unicode( str( self.lineTextLeft.text().utf8() ),"utf-8" )
		img.BoxLeft.TextFont = self.LeftFont
		img.BoxLeft.TextSize = self.LeftFontSize
		img.BoxLeft.TextColor = '#'+self.lineTextcolorLeft.text().ascii()
		img.BoxLeft.TextX = self.spinTextposLeftX.value()
		img.BoxLeft.TextY = self.spinTextposLeftY.value()
		img.BoxLeft.TextAutoX = self.checkLeftTextAutoX.isChecked()
		img.BoxLeft.TextAutoY = self.checkLeftTextAutoY.isChecked()
		img.BoxLeft.Color = '#'+self.lineBackcolorLeft.text().ascii()
		img.BoxLeft.ColorChecked = self.radioButton1_2.isChecked()
		img.BoxLeft.PicChecked = self.radioButton2_2.isChecked()
		img.BoxLeft.PicPath = self.lineImageLeft.text().utf8()
		img.BoxLeft.PicX = self.spinImageposLeftX.value()
		img.BoxLeft.PicY = self.spinImageposLeftY.value()
		img.BoxLeft.PicAutoX = self.checkLeftPicAutoX.isChecked()
		img.BoxLeft.PicAutoY = self.checkLeftPicAutoY.isChecked()
		img.BoxRight.X = self.spinRightX2.value()
		img.BoxRight.Y = self.spinRightY2.value()
		img.BoxRight.posX = self.spinRightX1.value()
		img.BoxRight.posY = self.spinRightY1.value()
		img.BoxRight.Text = unicode( str( self.lineTextRight.text().utf8() ),"utf-8" )
		img.BoxRight.TextFont = self.RightFont
		img.BoxRight.TextSize = self.RightFontSize
		img.BoxRight.TextColor = '#'+self.lineTextcolorRight.text().ascii()
		img.BoxRight.TextX = self.spinTextPosRightX.value()
		img.BoxRight.TextY = self.spinTextposRightY.value()
		img.BoxRight.TextAutoX = self.checkRightTextAutoX.isChecked()
		img.BoxRight.TextAutoY = self.checkRightTextAutoY.isChecked()
		img.BoxRight.Color = '#'+self.lineBackcolorRight.text().ascii()
		img.BoxRight.ColorChecked = self.radioButton1.isChecked()
		img.BoxRight.PicChecked = self.radioButton2.isChecked()
		img.BoxRight.PicPath = self.lineImageRight.text().utf8()
		img.BoxRight.PicX = self.spinImageposRightX.value()
		img.BoxRight.PicY = self.spinImageposRightY.value()
		img.BoxRight.PicAutoX = self.checkRightPicAutoX.isChecked()
		img.BoxRight.PicAutoY = self.checkRightPicAutoY.isChecked()
		return
	
	
	def update_all(self):
		self.setProp(self.my_img)
		klaus = self.my_img.draw()
		imageX = QPixmap()
		imageX.loadFromData( klaus.tostring("jpeg", "RGB") )	# only found possibility to get pic without saving
		self.pixImage.setPixmap(imageX)
	
	
	
	def save(self):
		fileName = QFileDialog.getSaveFileName( os.getcwd(), "Images (*.png *.xpm *.jpg)", self, "save file dialog" )
		if str( fileName.utf8() ) != '':
			klaus = self.my_img.draw()
			try:
				klaus.save( str( fileName.utf8() ), "PNG" )
			except:
				QMessageBox.critical(self, "Error", "Could not save file!")
		return
	
		
	def _color(self,name,pre_color):
		
		def _hex(a):
			if a > 9:
				if a == 10:
					a = 'A'
				elif a == 11:
					a = 'B'
				elif a == 12:
					a = 'C'
				elif a == 13:
					a = 'D'
				elif a == 14:
					a = 'E'
				else:
					a = 'F'
			return a
			
		color = QColorDialog.getColor(QColor(pre_color),self,"klaus")
		if color.isValid() == True:
			rgb = color.getRgb()
			hexcolor = ''
			for i in range( len(rgb) ):
				x = rgb[i] % 16
				y = rgb[i] / 16
				x = _hex(x)
				y = _hex(y)
				hexcolor = hexcolor + str(y) + str(x)
			name.setText(hexcolor)
		return
	
	def color_out(self):
		self._color(self.lineColorOut,'#'+self.lineColorOut.text().ascii())
		return
	
	def color_in(self):
		self._color(self.lineColorIn,'#'+self.lineColorIn.text().ascii())
		return
		
	def color_textLeft(self):
		self._color(self.lineTextcolorLeft,'#'+self.lineTextcolorLeft.text().ascii())
		return
		
	def color_backLeft(self):
		self._color(self.lineBackcolorLeft,'#'+self.lineBackcolorLeft.text().ascii())
		return
	
	def color_textRight(self):
		self._color(self.lineTextcolorRight,'#'+self.lineTextcolorRight.text().ascii())
		return
	
	def color_backRight(self):
		self._color(self.lineBackcolorRight,'#'+self.lineBackcolorRight.text().ascii())
		return
	
	def color(self):
		self._color(self.lineBackColour,'#'+self.lineBackColour.text().ascii())
		return
	
	# font-stuff
	def fontTest(self,sender):
		dirs = FontDir(self.FontConf)
		for i in range( len(dirs) ):
			result = fontDirProcess(dirs[i],fontStringProcess(self.font))
			if (result != None) and (result != 'none'):
				break
		if (result==None)or(result=='none')or(result[4]!='fontformat=TrueType'):
			if sender != 'none':
				QMessageBox.warning(self, 'Problem',
						     'The fontfile could not be found or the font is not in truetype format.\n'
						     'Please choose another one.')
			else:
				QMessageBox.critical(self, 'Problem',
				                      'The standard fontfile could not be found.\n'
						      'Please choose another one.')
			self._font(name=sender)
			return
		if sender == 'left':
			self.LeftFont = result[0]
			self.LeftFontSize = result[2]
		elif sender == 'right':
			self.RightFont = result[0]
			self.RightFontSize = result[2]
		else:
			self.LeftFont = result[0]
			self.LeftFontSize = result[2]
			self.RightFont = result[0]
			self.RightFontSize = result[2]
	
	def _font(self,name):
		if name == 'left':
			f = QFontDialog.getFont(self.qFontLeft,self)
		else:
			f = QFontDialog.getFont(self.qFontRight,self)
		if f[1]:
			if name == 'left':
				self.qFontLeft = f[0]
			else:
				self.qFontRight = f[0]
			s = f[0].toString()
			self.font = str(s)
			self.fontTest(name)
		else:
			if name == 'none':
				self.FontInit = False
				QMessageBox.critical(self, 'Problem',
				                           'The standard fontfile could not be set. '
							   'Without any font this app is quite senseless.\n'
						           'To avoid this problem, install some TrueType fonts.')
		return
		
	def font_left(self):
		self._font(name='left')
		return
		
	def font_right(self):
		self._font(name='right')
		return
	
	# info-box
	def info(self):
		QMessageBox.information( self,  'ButtonMaker',
					'This is a little tool for creating those '
					'tiny buttons you can find all around in the web these days.\n'
					'Author: Jerch\nLicense: GPL' )
		return
