# -*- coding: utf-8 -*-
import Image, ImageDraw, ImageFont

class Box:
	def __init__( self,
		      x=10, y=10, posX=5, posY=5,
		      text='Test', tSize=10, font='string', textColor='#FFFFFF', textX=0, textY=0, tAutoX=True, tAutoY=True,
		      bColor='#000000', colorChecked=True,
		      picChecked=False, picPath='', picX=0, picY=0, pAutoX=True, pAutoY=True):
		
		# box-size, position
		self.X = x
		self.Y = y
		self.posX = posX
		self.posY = posY
		
		# text-stuff
		self.Text = text
		self.TextSize = tSize
		self.TextFont = font
		self.TextColor = textColor
		self.TextX = textX
		self.TextY = textX
		self.TextAutoX = tAutoX
		self.TextAutoY = tAutoY
		
		# background
		self.Color = bColor
		self.ColorChecked = colorChecked
		
		# picture-stuff
		self.PicChecked = picChecked
		self.PicPath = picPath
		self.PicX = picX
		self.PicY = picY
		self.PicAutoX = pAutoX
		self.PicAutoY = pAutoY

class My_Image:
	def __init__(self):
		
		# create needed variables:
		# load initial image-size from spinbox
		self.X = 1
		self.Y = 1
		
		# background gray
		self.BackColor = '#808080'
		
		# initial borders
		self.BorderOutColor = '#FFFFFF'
		self.BorderOutThick = 1
		self.BorderInColor = '#000000'
		self.BorderInThick = 1
		
		# initial left box
		self.BoxLeft = Box()
		
		# initial right box
		self.BoxRight = Box()
	
	# draw border pos=0 for outer, pos=1 for inner
	def _drawBorder(self,pos,img,thick,color,thickOut):
		draw = ImageDraw.Draw(img)
		while thick >0:
			draw.line( (0+(thick-1)+pos*thickOut,
				    0+(thick-1)+pos*thickOut,
				    img.size[0]-thick-pos*thickOut,
				    0+(thick-1)+pos*thickOut),
				    fill=color)
			draw.line( (img.size[0]-thick-pos*thickOut,
				    0+(thick-1)+pos*thickOut,
				    img.size[0]-thick-pos*thickOut,
				    img.size[1]-thick+1-pos*thickOut),
				    fill=color)
			draw.line( (0+thick-1+pos*thickOut,
				    0+thick+pos*thickOut,
				    0+thick-1+pos*thickOut,
				    img.size[1]-thick+1-pos*thickOut),
				    fill=color)
			draw.line( (0+(thick-1)+pos*thickOut,
				    img.size[1]-(thick)-pos*thickOut,
				    img.size[0]-thick-pos*thickOut,
				    img.size[1]-(thick)-pos*thickOut),
				    fill=color)
			thick = thick-1
		return img
		
		
		
	def _drawBox(self,img,box):
		draw = ImageDraw.Draw(img)
		
		# box
		draw.rectangle((box.posX,box.posY,box.X+box.posX,box.Y+box.posY), fill=box.Color)
		
		# text
		if (box.Text != '') and (box.TextFont != ''):
			box.TextSize = int(box.TextSize)
			TextFont = ImageFont.truetype(box.TextFont, box.TextSize)
			pos = draw.textsize(box.Text, font=TextFont)
			if box.TextAutoX == True:
				tx = box.X/2-pos[0]/2+box.posX
			else:
				tx = box.TextX+box.posX
			if box.TextAutoY == True:
				ty = box.Y/2-pos[1]/2+box.posY-1
			else:
				ty = box.TextY+box.posY
			
			draw.text( (tx, ty),
			            box.Text,
				    font=TextFont,
				    fill=box.TextColor)
		
			
		return img
	
	def draw(self):
		image = Image.new("RGB", (self.X,self.Y), self.BackColor)
		
		# borders
		thickOut = self.BorderOutThick
		if self.BorderOutThick > 0:
			image = self._drawBorder(0,image,self.BorderOutThick,self.BorderOutColor,thickOut)
		if self.BorderInThick > 0:
			image = self._drawBorder(1,image,self.BorderInThick,self.BorderInColor,thickOut)
		
		# boxes
		if (self.BoxLeft.X > 0) and (self.BoxLeft.Y >0):
			image = self._drawBox(image,self.BoxLeft)
		if (self.BoxRight.X > 0) and (self.BoxRight.Y >0):
			image = self._drawBox(image,self.BoxRight)
		
		return image		# return the picture
	
		